# ArchiSync

Software di sincronizzazione fra cartelle locali del file system  e il servizio ArchiSmall attraverso le Api esposte 
dal servizio Archismall. 

Il sistema in base alle schedulazioni impostate invierà e ricevera le fatture elettroniche e/o le rispettive notifiche.

# Installation
  
  Per eseguire il programma è necessario impostare il file di configurazione ed 
  verificare che i percorsi mappati siano esistenti e acessibili.
  
  
# Usage

Il file di configurazione è diviso in tre parti:

## Configurazione credenziali client / consumer 
Al primo livello troviamo le inforazioni relative all'end point di riferimento e alle credenziali 
da usare per poter consumare le api.  
  
        "apiUrl": "URL_WS_QUALITY",
        "client_Id": "XXXX-client",
        "client_Secret": "XXX-secret-XXXXff",

Sul campo **apiUrl** sono ammessi solo  i valori **_URL_WS_QUALITY_  _URL_WS_PRODUCTION_** 

 ## Configurazione company
 Il secondo livello è dedicato alla configurazione dei dati aziendali e le credenziali dell'account 
 archismall associato.
 
    "lCompany": [
     {
       "company_name": "Archivist srl",
       "codiceFiscale": "02576660365",
       "idCodice": "02576660365",
       "idPaese": "IT",
       "smallUser": "info@archivist.it",
       "smallPassword": "**********"},
       ...
     {
            "company_name": "pippo srl",
             
 
 Nel caso fosse necessario gestire più aziende , i blocchi azienda andranno inseriti in sequenza 
 all'interno di **lCompany**-   
 
 ## Configurazione job
Al terzo livello troviamo la lista dei job che il programma dovrà eseguire.
       
     {
          "jobType": "UPLOADFATTURA",
          "jobRepeatInterval": 0,
          "jobFolderInput": "workdirectory/IT02576660365/UPLOADFATTURE/input",
          "jobFolderInProgress": "workdirectory/IT02576660365/UPLOADFATTURE/inprogress",
          "jobFolderElaborated": "workdirectory/IT02576660365/UPLOADFATTURE/elaborated",
          "jobFolderFailed": "workdirectory/IT02576660365/UPLOADFATTURE/failed",
          "jobFolderLog": "workdirectory/IT02576660365/UPLOADFATTURE/log",
          "jobFileFormat": "NONE"
        },

**jobType** corrisponde al tipo di job da eseguire.
I valori ammessi sono: **UPLOADFATTURA, NOTIFICHEFATTUREATTIVE, FATTUREPASSIVE**.
DACOMPILARE è utilizzato per creare il modello vuoto del file di configurazione.

**jobRepeatInterval** Rappresenta il tempo di attesa tra un job e il sucessivo espresso in minuti.
Se al momento dell'esecuzione del job ,il job precedente è ancora in corso la schedulazione sarà ignorata e si passerà alla successiva.
Con il valore impostato a 0 il job non sarà schedulato.

seguono le impostazioni delle cartelle di lavoro, a seconda dei casi dovranno essere compilate o meno in generale:
 
 La **cartella di input** è la cartella di arrivo dei file da spedire.
 
 La **cartella di inprogress** è lutilizzata dalla procedura serve ad evitare di elaborare sempre lo stesso file.
 
 La **cartella di elaborated** è la destinazione finale dei file elaborati o ricevuti.
 
 La **cartella di failed** può contenere i file scartati dal job.
 
 la **cartella di log**  contenere i log relativi al job e alle sue esecuzioni.
 
 infine troviamo il campo **jobFileFormat** utilizzato per impostare il formato del file per i job che prevedono il salvataggio di qualche oggetto.
 i valori ammessi al momento sono **XML, JSON, XML_FORMULA, XML_IGEA** NONE è utilizzato sui tracciati che non prevedono fil in uscita.  
 
 # parametri conessione
In coda al file troviamo i parametri utilizzati per la conessione, in generale questi valori non devono essere  modificati.

    "connectTimeout": 1,
    "writeTimeout": 1,
    "readTimeout": 1,
    "pagesize": 100,

 }
 
 # controllo doppia sessione
    "portCheck": 100
    
 per evitare la doppia sessione sono stati aggiunti due metodi :
 1 controllo tramite file: viene creato un file di lock sotto la workdirectory/my.lock in caso di kill bisogna eliminarlo 
 2 controllo sulla porta : viene creato un socket , attenzione alla porta da utilizzare e verifica che non ci sia lo share delle porte sul server.

i valori sui campi timeout sono espressi in minuti, mentre il pagesize può essere un valore compreso tra 0 e 100. 
 
# Documentation

# Running Tests

  Per eseguire i test è necessario:
 
 1. Disporre delle credenziali del consumenr e del account small.
 2. Chiedere al personale archivist di armare la sandbox.
 3. Impostare il file di configurazione. 
 
 # verifiche prima dell'invio
 1. conformita schema Schema_VFPR12.xsd
 2. corriscpondenza contenuto cartella input con codice cedente o fiscale del job.
  
# Contributing

Lorenzo Grisendi

Marco Panini

# License

CONTRATTO DI LICENZA CON L’UTENTE FINALE PER IL SOFTWARE ARCHIVIST
IMPORTANTE - LEGGERE CON ATTENZIONE: Il presente Contratto di Licenza con l’Utente Finale (“Contratto”) è un contratto intercorrente tra l’utente (una persona fisica o giuridica) e Archivist srl per il software Archivist relativo al presente Contratto, che include i supporti di memorizzazione ad esso associati e i servizi Archivist basati su Internet (“Software”). Il Software può includere un addendum o una modifica al presente Contratto. INSTALLANDO, DUPLICANDO O ALTRIMENTI UTILIZZANDO IL SOFTWARE, L’UTENTE ACCETTA DI ESSERE VINCOLATO DALLE CONDIZIONI DEL PRESENTE CONTRATTO. QUALORA L’UTENTE NON ACCETTI LE CONDIZIONI DEL PRESENTE CONTRATTO, ALLORA NON POTRÀ INSTALLARE, DUPLICARE O UTILIZZARE IL SOFTWARE E DOVRÀ RESTITUIRLO PRONTAMENTE AL RIVENDITORE. IN TALE IPOTESI, QUALORA AL MOMENTO DELL’ACQUISTO IL RIVENDITORE ABBIA EMESSO FATTURA, L’UTENTE POTRÀ OTTENERE IL RIMBORSO DEL PREZZO.
1.	CONCESSIONE DI LICENZA. Archivist concede all’utente i seguenti diritti, a condizione che egli si attenga alle condizioni del presente Contratto:
1.1	Installazione e Utilizzo. L’utente potrà:
	(a) installare e utilizzare una copia del Software su di un singolo computer o altro dispositivo; 
1.2	Concessione di Licenza per il Desktop Remoto. L’utente potrà utilizzare le tecnologie di accesso remoto, quali le funzionalità desktop remoto contenute in Microsoft Windows o NetMeeting, per accedere a, e utilizzare, la copia concessa in licenza del Software, a condizione che l’utente principale del dispositivo che ospita la sessione di desktop remoto sia l’unico ad accedere a, e utilizzare, il Software con un dispositivo di accesso remoto. Tali diritti relativi al desktop remoto non consentono all’utente di utilizzare il Software contemporaneamente sul dispositivo che ospita la sessione del desktop remoto e sul dispositivo di accesso.
1.3	Concessione di Licenza per l’Assistenza Remota. L’utente potrà consentire a qualsiasi dispositivo di accedere a, e utilizzare, la copia concessa in licenza del Software al solo scopo di fornire servizi di supporto tecnico e di manutenzione.
1.4	Concessione di Licenza per la Documentazione. La documentazione acclusa al Software è concessa in licenza esclusivamente per fini di riferimento interno e non commerciali.
1.5	Concessione di Licenza per i Modelli. Il Software potrà includere modelli di archivio. L’utente  potrà duplicare e modificare i modelli di archivio disponibili come parte del software Archivist accluso al presente Contratto e  distribuire tali modelli insieme alle modifiche effettuate per l’utilizzo da parte di altri licenziatari del Software.
L’utente non potrà effettuare alcuna delle operazioni riportate di seguito.
•	L’utente non potrà vendere, rivendere, concedere in licenza, in locazione, in leasing, in prestito o altrimenti trasferire a titolo oneroso i modelli.
•	L’utente non potrà distribuire i modelli disponibili tramite servizi basati su Internet come parte di qualsiasi prodotto o servizio.
•	L’utente non potrà duplicare o pubblicare i modelli disponibili tramite servizi basati su Internet su computer di rete o trasmetterli tramite qualsivoglia supporto di memorizzazione. 
L’utente dovrà indennizzare e difendere Archivist Srl da qualsiasi reclamo o azione giudiziale, ivi incluse le spese legali, che derivino da, o siano connessi a, la concessione di licenza o la distribuzione dei modelli modificati dall’utente.
2.	ALTRI DIRITTI E LIMITAZIONI
2.1	Attivazione Obbligatoria. IL SOFTWARE UTILIZZA TECNOLOGIE PER LA PROTEZIONE CONTRO L’UTILIZZO DI COPIE NON CONCESSE IN LICENZA O ILLEGALI. L’utente potrebbe non essere in grado di esercitare i propri diritti relativi al Software definiti nel presente Contratto dopo un certo numero di esecuzioni del Prodotto, a meno che non effettui l’attivazione della propria copia del Software nel modo descritto durante la sequenza di avvio. Potrebbe inoltre essere necessario attivare nuovamente il Software nel caso in cui l’utente modifichi la configurazione hardware del computer o alteri il Software. Archivist utilizzerà tali tecnologie per confermare il possesso di una copia regolarmente concessa in licenza del Software da parte dell’utente. Se l’utente non utilizza una copia del Software concessa in licenza, non  potrà installare il Software o i futuri aggiornamenti del Software. Archivist non recupererà dal dispositivo dell’utente alcuna informazione personale durante questo processo.
2.2	Servizi Basati su Internet. L’utente non potrà utilizzare alcun servizio Archivist basato su Internet associato al Software in alcun modo che potrebbe danneggiare, disattivare, sovraccaricare o pregiudicare tali servizi o interferire con l’utilizzo e il godimento degli stessi da parte di eventuali altri soggetti. L’utente non potrà tentare di accedere in modo non autorizzato a servizi, account, sistemi di computer o reti associati ai servizi basati su Internet. 
3.	RISERVA DI DIRITTI E PROPRIETÀ. Archivist si riserva tutti i diritti non espressamente concessi nel presente Contratto. Il Software è protetto dalle leggi e dai trattati sul copyright e sulla proprietà intellettuale. Archivist è proprietaria del nome, del copyright e di altri diritti sulla proprietà intellettuale inerenti al Software. Il Software non viene venduto, ma è concesso in licenza. Il presente Contratto non concede all’utente alcun diritto relativo ai marchi registrati o marchi di servizio di Archivist.
4.	RESTRIZIONI SULLA DECODIFICAZIONE, SULLA DECOMPILAZIONE E SUL DISASSEMBLAGGIO. L’utente non potrà decodificare, decompilare o disassemblare il Software, fatta eccezione per i casi in cui le suddette attività siano espressamente consentite dalla legge applicabile.
5.	DIVIETO DI HOSTING DI SERVIZI COMMERCIALI/LOCAZIONE. L’utente non potrà concedere il software in locazione, leasing, prestito, ovvero fornire hosting di servizi commerciali utilizzando il Software.
6.	CONSENSO ALL’UTILIZZO DEI DATI. L’utente accetta che Archivist raccolga e utilizzi le informazioni tecniche ottenute come parte di eventuali servizi di supporto forniti all’utente, relativi al Software. Archivist si impegna ad utilizzare queste informazioni esclusivamente per migliorare i prodotti o per fornire all’utente tecnologie o servizi personalizzati e in modo da non consentire l’individuazione della persona dell’utente.
7.	COLLEGAMENTI AI SITI DI TERZI. Archivist non è responsabile del contenuto di alcun sito o servizio di terzi, di eventuali collegamenti in essi contenuti  e di eventuali modifiche o aggiornamenti ai siti o ai servizi di terzi. Archivist fornisce all’utente tali collegamenti e l’accesso ai siti e ai servizi di terzi solo per motivi di praticità e l’inclusione di qualunque collegamento o accesso non implica il riconoscimento dei siti o dei servizi di terzi da parte di Archivist. 
8.	SOFTWARE E SERVIZI AGGIUNTIVI. Il presente Contratto si applica agli aggiornamenti, componenti integrativi, componenti add-on o servizi basati su Internet del Software che Archivist potrebbe fornire o rendere disponibili all’utente successivamente alla data in cui l’utente ha ottenuto il Software, a meno che tali elementi non siano accompagnati da specifiche condizioni. Archivist si riserva il diritto di interrompere qualunque servizio basato su Internet fornito all’utente o reso disponibile all’utente attraverso l’utilizzo del Software.
9.	AGGIORNAMENTI. Qualora il Software sia identificato come aggiornamento, per poterlo utilizzare, l’utente potrà prima ottenere la licenza per il software identificato da Archivist come idoneo per l’aggiornamento. Dopo aver installato l’aggiornamento, l’utente non potrà più utilizzare il software originale che ha costituito la base dell’aggiornamento, tranne che come parte del software aggiornato.
10.	SOFTWARE ETICHETTATO “CAMPIONE DIMOSTRATIVO. VIETATA LA VENDITA”. Qualora il Software sia identificato come “Campione dimostrativo. Vietata la Vendita” o “NFR” (“Not For Resale”), l’utilizzo del Software da parte dell’utente sarà limitato esclusivamente ai fini di dimostrazione, prova o valutazione e l’utente non potrà venderlo, trasferirlo o utilizzarlo per altri scopi.
11.	SEPARAZIONE DI COMPONENTI. Il Software è concesso in licenza come prodotto singolo. Le sue singole parti componenti non potranno essere separate per l’utilizzo su più dispositivi.
12.	TRASFERIMENTO DEL SOFTWARE. Interno. L’utente potrà trasferire la propria copia del Software ad un altro dispositivo. Dopo il trasferimento l’utente  dovrà rimuovere completamente il Software dal dispositivo su cui si trovava in precedenza. Trasferimento a Terzi. Qualora l’utente sia il licenziatario iniziale del Software, allora potrà trasferire una sola volta e definitivamente il presente Contratto, il Software e il Certificato di Autenticità (se applicabile) a un altro utente finale, a condizione che l’utente non trattenga alcuna copia del Software. Il trasferimento dovrà comprendere tutto il Software (inclusi tutti i supporti di memorizzazione, le parti componenti e il materiale stampato, qualsiasi aggiornamento, il presente Contratto e, se applicabile, il Certificato di Autenticità). Il trasferimento non dovrà essere effettuato sotto forma di invio o spedizione, ovvero di altro trasferimento indiretto. Prima del trasferimento l’utente finale cessionario del Software dovrà accettare le condizioni del presente Contratto.
13.	RISOLUZIONE. Qualora l’utente non si attenga alle condizioni del presente Contratto, Archivist potrà risolvere il Contratto stesso, senza per questo pregiudicare altri suoi diritti. In tal caso, l’utente  dovrà distruggere tutte le copie del Software e tutte le sue parti componenti.
14.	INTERO ACCORDO; DIVISIBILITÀ. Il presente Contratto (incluso ogni addendum o modifica presenti all’interno del Software) costituisce l’intero accordo tra l’utente e Archivist relativamente al Software e al servizio di supporto tecnico (se presente) e sostituisce qualsivoglia comunicazione, proposta o dichiarazione, scritta o orale, precedente o contemporanea attinente al Software o all’altra materia trattata nel presente Contratto. Nella misura in cui le condizioni di qualsivoglia criterio o programma Archivist relativi al servizio supporto tecnico si ponessero in conflitto con le condizioni del presente Contratto, prevarranno le condizioni del presente Contratto. Qualora qualsivoglia disposizione del presente Contratto sia ritenuta nulla, non valida, non applicabile o illegale, le altre disposizioni rimarranno pienamente vincolanti ed efficaci.


Garanzia di Archivist.  La presente garanzia non pregiudica i diritti riconosciuti dalla legge. – La garanzia di seguito indicata non ha limitazioni territoriali e non è pregiudizievole per i diritti riconosciuti dalla legge all’utente nei confronti del rivenditore o di Archivist qualora l’utente abbia acquistato il Software direttamente da Archivist. 

La garanzia – Il Software è progettato e offerto quale prodotto a scopo generale, e non è progettato o offerto per scopi particolari dell’utente.  L’utente accetta che nessun prodotto software è esente da errori e riconosce di essere stato specificamente avvisato della necessità di effettuare periodicamente il “back up” dei suoi file.  A condizione che l’utente abbia una licenza valida, Archivist garantisce che a) il Software funzionerà in sostanziale conformità con i materiali scritti ad esso acclusi per un periodo di 90 giorni dalla data in cui l’utente riceve la licenza per utilizzare il Software o per il periodo minimo consentito dalla legge applicabile; e b) qualsiasi servizio di supporto fornito da Archivist corrisponderà sostanzialmente a quanto descritto negli applicabili materiali scritti forniti all’utente da Archivist e il personale tecnico di Archivist porrà in essere ragionevoli sforzi, ed userà diligenza e professionalità per risolvere i problemi. Nel caso in cui il Software non sia conforme alla presente garanzia, Archivist potrà (a) riparare o sostituire il Software o (b) restituire il prezzo pagato dall’utente. La presente garanzia non è valida qualora il mancato funzionamento del Software dipenda da incidente, oppure da abusivo o errato utilizzo. Qualsiasi prodotto software dato in sostituzione sarà garantito per il periodo più lungo tra 30 giorni e il periodo rimanente della garanzia originale. L’utente accetta che la garanzia di cui sopra è la sua unica garanzia in relazione al Software e ai servizi di supporto.
 
Esclusione di Tutte le Altre Condizioni – Nella misura massima consentita dalla legge applicabile, e subordinatamente alla garanzia sopra indicata, Archivist non riconosce alcun’altra garanzia o condizione, esplicite o implicite (siano esse derivanti dalla legge, dagli usi, da altre fonti, ovvero siano garanzie accessorie) comprese, a titolo esemplificativo, garanzie implicite di qualità soddisfacente e di idoneità per un fine particolare, sia in relazione al Software che ai materiali scritti acclusi al Software. Le garanzie implicite che non possono essere escluse sono comunque limitate al periodo maggiore tra 90 giorni e il periodo minimo consentito dalla legge applicabile.

Limitazione di Responsabilità – Nella misura massima consentita dalla legge applicabile, e fatto salvo quanto indicato nella Garanzia di Archivist, Archivist e i suoi distributori non saranno responsabili per danni di qualsiasi tipo (ivi inclusi, a titolo esemplificativo, danni per perdita o mancato guadagno, interruzione dell’attività, perdita di informazioni commerciali o altre perdite pecuniarie) derivanti o comunque correlati all’utilizzo o all’incapacità di utilizzare il Software, anche nel caso in cui Archivist sia stata avvisata della possibilità del verificarsi di tali danni. In ogni caso, la responsabilità complessiva di Archivist in base alle disposizioni del presente Contratto non potrà comunque eccedere l’importo effettivamente pagato dall’utente per il Software. Le presenti limitazioni non si applicano alle responsabilità che non possono essere escluse o limitate in base alle leggi applicabili.
 
Legge regolatrice –   Il presente Contratto è disciplinato dalle leggi dello Stato Italiano.

Chiunque desideri porre domande in ordine a questo Contratto o contattare Archivist per qualunque ragione, può rivolgersi alla casa madre Archivist srl, le cui informazioni relative all’indirizzo sono accluse al Software, ovvero visitare Archivist sul World Wide Web al seguente indirizzo: http://www.archivist.it.

